function Create(self)
	self.alliedTeam = -1
	self.lastAngle = self.RotAngle
	self.lastVel = Vector(self.Vel.X, self.Vel.Y)
end

function Update(self)
	self.lastAngle = self.RotAngle
	self.lastVel = Vector(self.Vel.X, self.Vel.Y)

	if self.ID == self.RootID and self.alliedTeam == -1 then
		self.curdist = 500
		for actor in MovableMan.Actors do
			local dist = SceneMan:ShortestDistance(self.Pos, actor.Pos, SceneMan.SceneWrapsX).Magnitude
			if dist < self.curdist then
				self.curdist = dist
				self.alliedTeam = ToActor(actor).Team
			end
		end
	end

	local rayHitPos = Vector(0, 0)
	local terrainRaycast = SceneMan:CastStrengthRay(
		self.Pos,
		Vector(self.Vel.X, self.Vel.Y):SetMagnitude(250),
		0,
		rayHitPos,
		0,
		0,
		SceneMan.SceneWrapsX
	)

	if terrainRaycast == true then
		for i = 1, 12 do
			local mine = CreateMOSRotating("Particle MD Mine")
			mine.Pos = self.Pos
			mine.Vel = self.Vel + Vector((math.random() * 15) + 5, 0):RadRotate(math.random() * (math.pi * 2))
			mine.Sharpness = self.alliedTeam
			MovableMan:AddParticle(mine)
			self:GibThis()
		end
	end
end

function Destroy(self)
	local gibA = CreateMOSRotating("MD Cluster Bomb Gib1")
	gibA.Pos = self.Pos
	gibA.Vel = self.Vel
	gibA.RotAngle = self.lastAngle
	MovableMan:AddParticle(gibA)

	local gibB = CreateMOSRotating("MD Cluster Bomb Gib2")
	gibB.Pos = self.Pos + Vector(1, -3):RadRotate(self.lastAngle)
	gibB.Vel = self.Vel + Vector(0, 20):RadRotate(self.lastAngle)
	gibB.AngularVel = 20
	gibB.RotAngle = self.lastAngle
	MovableMan:AddParticle(gibB)

	local gibC = CreateMOSRotating("MD Cluster Bomb Gib3")
	gibC.Pos = self.Pos + Vector(1, 4):RadRotate(self.lastAngle)
	gibC.Vel = self.Vel + Vector(0, -20):RadRotate(self.lastAngle)
	gibC.AngularVel = -20
	gibC.RotAngle = self.lastAngle
	MovableMan:AddParticle(gibC)

	local gibD = CreateMOSRotating("MD Cluster Bomb Gib4")
	gibD.Pos = self.Pos + Vector(1, -3):RadRotate(self.lastAngle)
	gibD.Vel = self.Vel + Vector(0, 20):RadRotate(self.lastAngle)
	gibD.AngularVel = 20
	gibD.RotAngle = self.lastAngle
	MovableMan:AddParticle(gibD)

	local gibE = CreateMOSRotating("MD Cluster Bomb Gib5")
	gibE.Pos = self.Pos + Vector(1, 4):RadRotate(self.lastAngle)
	gibE.Vel = self.Vel + Vector(0, -20):RadRotate(self.lastAngle)
	gibE.AngularVel = -20
	gibE.RotAngle = self.lastAngle
	MovableMan:AddParticle(gibE)
end
